## libftdi1 1.5

=== CMakeLists.txt ===
# Project
project(libftdi1 C)
set(MAJOR_VERSION 1)
set(MINOR_VERSION 5)
set(PACKAGE libftdi1)
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION})
set(VERSION ${VERSION_STRING})
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# CMake
if("${CMAKE_BUILD_TYPE}" STREQUAL "")
   set(CMAKE_BUILD_TYPE     RelWithDebInfo)
endif("${CMAKE_BUILD_TYPE}" STREQUAL "")
set(CMAKE_COLOR_MAKEFILE ON)
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

add_definitions(-Wall)

include(CMakeOptions.txt)

# Debug build
message("-- Build type: ${CMAKE_BUILD_TYPE}")
if(${CMAKE_BUILD_TYPE} STREQUAL Debug)
   add_definitions(-DDEBUG)
endif(${CMAKE_BUILD_TYPE} STREQUAL Debug)

# find libusb
find_package ( USB1 REQUIRED )
include_directories ( ${LIBUSB_INCLUDE_DIR} )

# Find Boost
if (FTDIPP OR BUILD_TESTS)
  find_package( Boost REQUIRED )
endif()

# Set components
set(CPACK_COMPONENTS_ALL sharedlibs staticlibs headers)
set(CPACK_COMPONENT_SHAREDLIBS_DISPLAY_NAME "Shared libraries")
set(CPACK_COMPONENT_STATICLIBS_DISPLAY_NAME "Static libraries")
set(CPACK_COMPONENT_HEADERS_DISPLAY_NAME "C++ Headers")

set(CPACK_COMPONENT_SHAREDLIBS_DESCRIPTION
"Shared library for general use.")
set(CPACK_COMPONENT_STATICLIBS_DESCRIPTION
"Static library, good if you want to embed libftdi1 in your application.")
set(CPACK_COMPONENT_HEADERS_DESCRIPTION
"C/C++ header files.")

set(CPACK_COMPONENT_SHAREDLIBS_GROUP "Development")
set(CPACK_COMPONENT_STATICLIBS_GROUP "Development")
set(CPACK_COMPONENT_HEADERS_GROUP    "Development")

# guess LIB_SUFFIX, don't take debian multiarch into account 
if ( NOT DEFINED LIB_SUFFIX )
  if( CMAKE_SYSTEM_NAME MATCHES "Linux"
      AND NOT CMAKE_CROSSCOMPILING
      AND NOT EXISTS "/etc/debian_version"
      AND NOT EXISTS "/etc/arch-release" )
    if ( "${CMAKE_SIZEOF_VOID_P}" EQUAL "8" )
      set ( LIB_SUFFIX 64 )
    endif ()
  endif ()
endif ()

if(NOT APPLE)
  if(CMAKE_SIZEOF_VOID_P EQUAL 4)
      SET(PACK_ARCH "")
    else(CMAKE_SIZEOF_VOID_P EQUAL 8)
      SET(PACK_ARCH .x86_64)
  endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
else(NOT APPLE)
  SET(PACK_ARCH "")
endif(NOT APPLE)

# Package information
set(CPACK_PACKAGE_VERSION              ${VERSION_STRING})
set(CPACK_PACKAGE_CONTACT              "Intra2net AG <libftdi@developer.intra2net.com>")
set(CPACK_PACKAGE_DESCRIPTION          "libftdi1 library.")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY  ${CPACK_PACKAGE_DESCRIPTION}
                                       )
# Package settings
if ( UNIX )
  set(CPACK_GENERATOR                    "DEB;RPM")
  set(CPACK_CMAKE_GENERATOR              "Unix Makefiles")
  set(CPACK_PACKAGE_NAME                 ${PROJECT_NAME})
  set(CPACK_PACKAGE_FILE_NAME            ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}${PACK_ARCH})
endif ()

if ( WIN32 )
  set ( CPACK_GENERATOR                    "NSIS" )
  set ( CPACK_CMAKE_GENERATOR              "MinGW Makefiles" )
  set ( CPACK_PACKAGE_NAME                 "${PROJECT_NAME}" )
  set ( CPACK_PACKAGE_VENDOR               "" )
  set ( CPACK_PACKAGE_INSTALL_DIRECTORY    "libftdi1" )
  set ( CPACK_PACKAGE_FILE_NAME            "${PROJECT_NAME}-${VERSION_STRING}-win32")
  set ( CPACK_NSIS_DISPLAY_NAME            "libftdi1" )
  set ( CPACK_NSIS_MODIFY_PATH             ON )
endif ()

set(CPACK_RESOURCE_FILE_LICENSE        ${CMAKE_SOURCE_DIR}/LICENSE)

set(CPACK_SOURCE_GENERATOR             TGZ)
set(CPACK_SOURCE_IGNORE_FILES          "\\\\.git;~$;build/")
set(CPACK_SOURCE_PACKAGE_FILE_NAME     ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION})

# Subdirectories
if ( UNIX )
  set ( CPACK_SET_DESTDIR ON )
endif ()

# "make dist" target
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${VERSION_STRING})
add_custom_target(dist
    COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
            | bzip2 > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

if ( DOCUMENTATION )
   find_package ( Doxygen REQUIRED)

   # Copy doxy.config.in
   set(top_srcdir ${CMAKE_SOURCE_DIR})
   configure_file(${CMAKE_SOURCE_DIR}/doc/Doxyfile.in ${CMAKE_BINARY_DIR}/Doxyfile )
   configure_file(${CMAKE_SOURCE_DIR}/doc/Doxyfile.xml.in ${CMAKE_BINARY_DIR}/Doxyfile.xml )

   # Run doxygen
   add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/doc/html/index.html
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/doc
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
    DEPENDS ${c_headers};${c_sources};${cpp_sources};${cpp_headers}
   )

   add_custom_target(docs ALL DEPENDS ${CMAKE_BINARY_DIR}/doc/html/index.html)
endif ()

add_subdirectory(src)
if ( FTDIPP )
  project(libftdipp1 C CXX)
  add_subdirectory(ftdipp)
endif ()
if ( PYTHON_BINDINGS )
add_subdirectory(python)
endif ()
if ( FTDI_EEPROM )
  add_subdirectory(ftdi_eeprom)
endif ()
if ( EXAMPLES )
  add_subdirectory(examples)
endif ()
add_subdirectory(packages)
if ( BUILD_TESTS )
  add_subdirectory(test)
endif ()

# PkgConfig
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
set(includedir  ${CMAKE_INSTALL_PREFIX}/include/${PROJECT_NAME})

if(${UNIX})
   set(libdir      ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
endif(${UNIX})
if(${WIN32})
   set(libdir      ${CMAKE_INSTALL_PREFIX}/bin)
endif(${WIN32})

configure_file(${CMAKE_SOURCE_DIR}/libftdi1.pc.in ${CMAKE_BINARY_DIR}/libftdi1.pc @ONLY)
configure_file(${CMAKE_SOURCE_DIR}/libftdipp1.pc.in ${CMAKE_BINARY_DIR}/libftdipp1.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/libftdi1.pc ${CMAKE_BINARY_DIR}/libftdipp1.pc
        DESTINATION lib${LIB_SUFFIX}/pkgconfig)

if (UNIX OR MINGW)
  configure_file ( libftdi1-config.in ${CMAKE_CURRENT_BINARY_DIR}/libftdi1-config @ONLY )
  install ( PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/libftdi1-config
            DESTINATION bin )
endif ()

# config script install path
if ( NOT DEFINED LIBFTDI_CMAKE_CONFIG_DIR )
  set ( LIBFTDI_CMAKE_CONFIG_DIR lib${LIB_SUFFIX}/cmake/libftdi1 )
endif ()

set ( LIBFTDI_INCLUDE_DIR ${includedir} )
set ( LIBFTDI_INCLUDE_DIRS ${LIBFTDI_INCLUDE_DIR} )
set ( LIBFTDI_LIBRARY ftdi1 )
set ( LIBFTDI_LIBRARIES ${LIBFTDI_LIBRARY} )
list ( APPEND LIBFTDI_LIBRARIES ${LIBUSB_LIBRARIES} )
set ( LIBFTDI_STATIC_LIBRARY ftdi1.a )
set ( LIBFTDI_STATIC_LIBRARIES ${LIBFTDI_STATIC_LIBRARY} )
list ( APPEND LIBFTDI_STATIC_LIBRARIES ${LIBUSB_LIBRARIES} )
if ( FTDIPP )
  set ( LIBFTDIPP_LIBRARY ftdipp1 )
  set ( LIBFTDIPP_LIBRARIES ${LIBFTDIPP_LIBRARY} )
  list ( APPEND LIBFTDIPP_LIBRARIES ${LIBUSB_LIBRARIES} )
endif ()
set ( LIBFTDI_LIBRARY_DIRS ${libdir} )
set ( LIBFTDI_ROOT_DIR ${prefix} )
set ( LIBFTDI_VERSION_STRING ${VERSION_STRING} )
set ( LIBFTDI_VERSION_MAJOR ${MAJOR_VERSION} )
set ( LIBFTDI_VERSION_MINOR ${MINOR_VERSION} )

set ( LIBFTDI_USE_FILE ${CMAKE_INSTALL_PREFIX}/${LIBFTDI_CMAKE_CONFIG_DIR}/UseLibFTDI1.cmake )

if(CMAKE_VERSION VERSION_LESS 2.8.8) 
  configure_file ( cmake/LibFTDI1Config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1Config.cmake @ONLY )
  configure_file ( cmake/LibFTDI1ConfigVersion.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1ConfigVersion.cmake @ONLY )
else ()
  include(CMakePackageConfigHelpers)

  configure_package_config_file (
    cmake/LibFTDI1Config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1Config.cmake
    INSTALL_DESTINATION ${LIBFTDI_CMAKE_CONFIG_DIR}
    PATH_VARS
      LIBFTDI_USE_FILE
      LIBFTDI_ROOT_DIR
      LIBFTDI_INCLUDE_DIR
      LIBFTDI_INCLUDE_DIRS
      LIBFTDI_LIBRARY_DIRS
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
  )
  write_basic_package_version_file (
    LibFTDI1ConfigVersion.cmake 
    VERSION ${LIBFTDI_VERSION_STRING} 
    COMPATIBILITY AnyNewerVersion
  )
endif ()


install ( FILES 
            ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1Config.cmake
            ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1ConfigVersion.cmake
            cmake/UseLibFTDI1.cmake

          DESTINATION ${LIBFTDI_CMAKE_CONFIG_DIR}
        )

include(CPack)

message (STATUS "Summary of build options:

  Build static libs: ${STATICLIBS}
  Build C++ bindings: ${FTDIPP}
  Build Python bindings: ${PYTHON_BINDINGS}
  Build ftdi_eeprom: ${FTDI_EEPROM}
  Build examples: ${EXAMPLES}
  Build tests: ${BUILD_TESTS}
  Build API documentation: ${DOCUMENTATION}
")

=== examples/CMakeLists.txt ===
# Includes
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_CURRENT_BINARY_DIR}
		)

# Targets
add_executable(simple simple.c)
add_executable(bitbang bitbang.c)
add_executable(bitbang2 bitbang2.c)
add_executable(bitbang_cbus bitbang_cbus.c)
add_executable(bitbang_ft2232 bitbang_ft2232.c)
add_executable(find_all find_all.c)
add_executable(serial_test serial_test.c)
add_executable(baud_test baud_test.c)
add_executable(stream_test stream_test.c)
add_executable(eeprom eeprom.c)
add_executable(async async.c)
add_executable(purge_test purge_test.c)

# Linkage
target_link_libraries(simple ftdi1)
target_link_libraries(bitbang ftdi1)
target_link_libraries(bitbang2 ftdi1)
target_link_libraries(bitbang_cbus ftdi1)
target_link_libraries(bitbang_ft2232 ftdi1)
target_link_libraries(find_all ftdi1)
target_link_libraries(serial_test ftdi1)
target_link_libraries(baud_test ftdi1)
target_link_libraries(stream_test ftdi1)
target_link_libraries(eeprom ftdi1)
target_link_libraries(async ftdi1)
target_link_libraries(purge_test ftdi1)

# libftdi++ examples
if( FTDIPP )
	include_directories(BEFORE ${CMAKE_SOURCE_DIR}/ftdipp
			${Boost_INCLUDE_DIRS})

	# Target
	add_executable(find_all_pp find_all_pp.cpp)

	# Linkage
	target_link_libraries(find_all_pp ftdipp1)
endif( FTDIPP )

# Source includes
include_directories(BEFORE ${CMAKE_SOURCE_DIR}/src)

=== ftdi_eeprom/CMakeLists.txt ===
find_package ( Confuse REQUIRED )
find_package ( Libintl )

# determine docdir
include(GNUInstallDirs)
if(NOT CMAKE_INSTALL_DOCDIR)
  if(WIN32)
    set(CMAKE_INSTALL_DOCDIR .)
  else(WIN32)
    set(CMAKE_INSTALL_DOCDIR ${CMAKE_INSTALL_DATAROOTDIR}/doc/${PROJECT_NAME})
  endif(WIN32)
endif(NOT CMAKE_INSTALL_DOCDIR)

message(STATUS "Building ftdi_eeprom")

include_directories ( ${CONFUSE_INCLUDE_DIRS} )
list ( APPEND libs ${CONFUSE_LIBRARIES} )

if ( LIBINTL_FOUND )
  include_directories ( ${LIBINTL_INCLUDE_DIR} )
  list ( APPEND libs ${LIBINTL_LIBRARIES} )
endif ()


# Version defines
set ( EEPROM_MAJOR_VERSION 0 )
set ( EEPROM_MINOR_VERSION 17 )
set ( EEPROM_VERSION_STRING ${EEPROM_MAJOR_VERSION}.${EEPROM_MINOR_VERSION} )

include_directories ( BEFORE ${CMAKE_SOURCE_DIR}/src )
include_directories ( BEFORE ${CMAKE_CURRENT_BINARY_DIR} )

configure_file(
               ftdi_eeprom_version.h.in
              ${CMAKE_CURRENT_BINARY_DIR}/ftdi_eeprom_version.h
)

add_executable ( ftdi_eeprom main.c )
target_link_libraries ( ftdi_eeprom ftdi1 ${CONFUSE_LIBRARIES} )
if ( LIBINTL_FOUND )
  target_link_libraries ( ftdi_eeprom ${LIBINTL_LIBRARIES} )
endif ()
install ( TARGETS ftdi_eeprom DESTINATION bin )
install ( FILES example.conf DESTINATION ${CMAKE_INSTALL_DOCDIR} )

=== ftdipp/CMakeLists.txt ===
# vim: ts=2:sw=2:sts=2

# Targets
set(cpp_sources ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.cpp CACHE INTERNAL "List of cpp sources" )
set(cpp_headers ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.hpp CACHE INTERNAL "List of cpp headers" )

# Includes
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/src)

include_directories(${Boost_INCLUDE_DIRS})

# Shared library
add_library(ftdipp1 SHARED ${cpp_sources})

math(EXPR VERSION_FIXUP "${MAJOR_VERSION} + 1")    # Compatibility with previous releases
set_target_properties(ftdipp1 PROPERTIES VERSION ${VERSION_FIXUP}.${MINOR_VERSION}.0 SOVERSION 3)

# Prevent clobbering each other during the build
set_target_properties(ftdipp1 PROPERTIES CLEAN_DIRECT_OUTPUT 1)

# Dependencies
target_link_libraries(ftdipp1 ftdi1 ${LIBUSB_LIBRARIES} ${BOOST_LIBRARIES})

install ( TARGETS ftdipp1
					RUNTIME DESTINATION bin
					LIBRARY DESTINATION lib${LIB_SUFFIX}
					ARCHIVE DESTINATION lib${LIB_SUFFIX}
				)

# Static library
if ( STATICLIBS )
	add_library(ftdipp1-static STATIC ${cpp_sources})
	set_target_properties(ftdipp1-static PROPERTIES OUTPUT_NAME "ftdipp1")
	set_target_properties(ftdipp1-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)

	install ( TARGETS ftdipp1-static
						ARCHIVE DESTINATION lib${LIB_SUFFIX}
						COMPONENT staticlibs
					)
endif ()

install ( FILES ${cpp_headers}
					DESTINATION include/${PROJECT_NAME}
					COMPONENT headers
				)

=== python/CMakeLists.txt ===
# swig_add_library behavior changed in cmake 3.13 to no longer set
# SWIG_MODULE_<target>_REAL_NAME, so restore the old behavior.
if ( POLICY CMP0078 )
  cmake_policy( SET CMP0078 OLD )
endif ()

# workaround for cmake bug #0013449
if ( NOT DEFINED CMAKE_FIND_ROOT_PATH OR NOT CMAKE_VERSION VERSION_LESS 3.0.0 )
  find_package ( SWIG REQUIRED )
else ()
  find_program ( SWIG_EXECUTABLE NAMES swig2.0 swig )
  if ( SWIG_EXECUTABLE )
    set ( SWIG_USE_FILE ${CMAKE_ROOT}/Modules/UseSWIG.cmake )
    set ( SWIG_FOUND TRUE )
  endif ()
endif ()
find_package ( PythonInterp REQUIRED )
find_package ( PythonLibs REQUIRED )

include ( UseSWIG )
include_directories ( BEFORE ${CMAKE_SOURCE_DIR}/src )
include_directories ( ${PYTHON_INCLUDE_DIRS} )
link_directories ( ${CMAKE_CURRENT_BINARY_DIR}/../src )

if ( DOCUMENTATION )
  set(CMAKE_SWIG_FLAGS -DDOXYGEN=${DOXYGEN_FOUND})
  # manually add dependency for new cmake / swig versions
  set_property(SOURCE ftdi1.i PROPERTY DEPENDS ftdi1_doc.i)
endif()
if(NOT CMAKE_VERSION VERSION_LESS 3.8.0)
  swig_add_library ( ftdi1 LANGUAGE python SOURCES ftdi1.i )
else ()
  swig_add_module ( ftdi1 python ftdi1.i )
endif()
swig_link_libraries ( ftdi1 ftdi1 )

if ( LINK_PYTHON_LIBRARY )
  swig_link_libraries ( ftdi1 ${PYTHON_LIBRARIES} )
elseif( APPLE )
  set_target_properties ( ${SWIG_MODULE_ftdi1_REAL_NAME} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup" )
endif ()

set_target_properties ( ${SWIG_MODULE_ftdi1_REAL_NAME} PROPERTIES NO_SONAME ON )

execute_process ( COMMAND ${PYTHON_EXECUTABLE} -c "from distutils import sysconfig; print( sysconfig.get_python_lib( plat_specific=True, prefix='${CMAKE_INSTALL_PREFIX}' ) )"
                  OUTPUT_VARIABLE _ABS_PYTHON_MODULE_PATH
                  OUTPUT_STRIP_TRAILING_WHITESPACE )

get_filename_component ( _ABS_PYTHON_MODULE_PATH ${_ABS_PYTHON_MODULE_PATH} ABSOLUTE )
file ( RELATIVE_PATH _REL_PYTHON_MODULE_PATH ${CMAKE_INSTALL_PREFIX} ${_ABS_PYTHON_MODULE_PATH} )

set ( PYTHON_MODULE_PATH ${_REL_PYTHON_MODULE_PATH} )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/ftdi1.py DESTINATION ${PYTHON_MODULE_PATH} )
install ( TARGETS ${SWIG_MODULE_ftdi1_REAL_NAME} LIBRARY DESTINATION ${PYTHON_MODULE_PATH} )

if ( DOCUMENTATION )
    # Run doxygen to only generate the xml
    add_custom_command ( OUTPUT ${CMAKE_BINARY_DIR}/doc/xml/ftdi_8c.xml
        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/doc
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile.xml
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        DEPENDS ${c_headers};${c_sources};${cpp_sources};${cpp_headers}
    )

    # generate .i from doxygen .xml
    add_custom_command ( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ftdi1_doc.i
        COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/doxy2swig.py -n
            ${CMAKE_BINARY_DIR}/doc/xml/ftdi_8c.xml
            ${CMAKE_CURRENT_BINARY_DIR}/ftdi1_doc.i
        DEPENDS ${CMAKE_BINARY_DIR}/doc/xml/ftdi_8c.xml
    )
    add_custom_target ( doc_i DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/ftdi1_doc.i )
    add_dependencies( ${SWIG_MODULE_ftdi1_REAL_NAME} doc_i )

endif ()

set ( LIBFTDI_PYTHON_MODULE_PATH ${CMAKE_INSTALL_PREFIX}/${PYTHON_MODULE_PATH} )
set ( LIBFTDI_PYTHON_MODULE_PATH ${LIBFTDI_PYTHON_MODULE_PATH} PARENT_SCOPE ) # for ftdiconfig.cmake

add_subdirectory ( examples )

=== src/CMakeLists.txt ===
# Includes
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}
                     ${CMAKE_CURRENT_SOURCE_DIR}
                     )

# Version information
set(SNAPSHOT_VERSION "unknown")
execute_process(COMMAND git describe
                OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
                RESULT_VARIABLE GIT_DESCRIBE_RESULT
                OUTPUT_STRIP_TRAILING_WHITESPACE
                )
if(${GIT_DESCRIBE_RESULT} STREQUAL 0)
  set(SNAPSHOT_VERSION ${GIT_DESCRIBE_OUTPUT})
endif ()
message(STATUS "Detected git snapshot version: ${SNAPSHOT_VERSION}")

configure_file(ftdi_version_i.h.in "${CMAKE_CURRENT_BINARY_DIR}/ftdi_version_i.h" @ONLY)

# Targets
set(c_sources     ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.c ${CMAKE_CURRENT_SOURCE_DIR}/ftdi_stream.c CACHE INTERNAL "List of c sources" )
set(c_headers     ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.h CACHE INTERNAL "List of c headers" )

add_library(ftdi1 SHARED ${c_sources})

math(EXPR VERSION_FIXUP "${MAJOR_VERSION} + 1")    # Compatibility with previous releases
set_target_properties(ftdi1 PROPERTIES VERSION ${VERSION_FIXUP}.${MINOR_VERSION}.0 SOVERSION 2)
# Prevent clobbering each other during the build
set_target_properties ( ftdi1 PROPERTIES CLEAN_DIRECT_OUTPUT 1 )


# Dependencies
target_link_libraries(ftdi1 ${LIBUSB_LIBRARIES})

install ( TARGETS ftdi1
          RUNTIME DESTINATION bin
          LIBRARY DESTINATION lib${LIB_SUFFIX}
          ARCHIVE DESTINATION lib${LIB_SUFFIX}
        )

if ( STATICLIBS )
  add_library(ftdi1-static STATIC ${c_sources})
  target_link_libraries(ftdi1-static ${LIBUSB_LIBRARIES})
  set_target_properties(ftdi1-static PROPERTIES OUTPUT_NAME "ftdi1")
  set_target_properties(ftdi1-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
  install ( TARGETS ftdi1-static
            ARCHIVE DESTINATION lib${LIB_SUFFIX}
            COMPONENT staticlibs
          )
endif ()

install ( FILES ${c_headers}
          DESTINATION include/${PROJECT_NAME}
          COMPONENT headers
        )

=== test/CMakeLists.txt ===
find_package(Boost COMPONENTS unit_test_framework REQUIRED)

enable_testing()

INCLUDE_DIRECTORIES(BEFORE ${CMAKE_SOURCE_DIR}/src ${Boost_INCLUDE_DIRS})

set(cpp_tests basic.cpp baudrate.cpp)

add_executable(test_libftdi1 ${cpp_tests})
target_link_libraries(test_libftdi1 ftdi1 ${Boost_UNIT_TEST_FRAMEWORK_LIBRARIES})

add_test(test_libftdi1 test_libftdi1)

# Add custom target so we run easily run "make check"
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} DEPENDS test_libftdi1)

=== debian/changelog ===
libftdi1 (1.5-10) unstable; urgency=medium

  * Build documentation in a separate pass and move some Build-
    Dependencies to Build-Depends-Arch and Build-Depends-Indep
  * Install python bindings with CMAKE_INSTALL_ALWAYS=1
  * Bump Standards-Version to 4.7.2 (no changes)
  * Remove debian/rules.ok

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 08 Apr 2025 22:40:49 +0200

libftdi1 (1.5-9) unstable; urgency=medium

  * Add Vcs-git and Vcs-browser to debian/control
  * Replace 03-cmake-project.diff by upstream version
  * Replace 04-swig-4.3.diff by upstream version
  * Set DEB_BUILD_MAINT_OPTIONS = hardening=+all to make lintian happier
  * Improve the libftdi1-dev, libftdi1-doc, and libftdipp1-dev
    descriptions
  * Fix cross-build
  * Rewrite debian/copyright in Machine-readable format
  * Only run the testsuite for arch:any builds
  * Simplify clean rule
  * Drop build-dependency version already satisfied in oldoldstable

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 07 Apr 2025 20:26:13 +0200

libftdi1 (1.5-8) unstable; urgency=medium

  * Add submitted patch to fix compatibility with SWIG 4.3 (closes: #1091128).

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 22 Dec 2024 18:13:45 +0000

libftdi1 (1.5-7) unstable; urgency=medium

  * Build-Depends on pkgconf instead of pkg-config.
  * Add an explicitly Build-Depends on python3-setuptools (closes: #1080636).
  * Bump Standards-Version to 4.7.0 (no changes).
  * Stop forcing -std=c++11, the GCC 6 transition is finished for long.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 07 Sep 2024 13:55:06 +0000

libftdi1 (1.5-6) unstable; urgency=medium

  * debian/libftdipp1-3.symbols: mark internal boost::detail::sp_counted
    symbols as optional as they disappear when using LTO (closes: #1015489).
  * Bump Standards-Version to 4.6.1 (no changes).
  * Push debhelper level to 13.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 14 Sep 2022 20:16:56 +0000

libftdi1 (1.5-5) unstable; urgency=medium

  * Rename _ftdi1.so into _ftdi1.${EXT_SUFFIX} after installing it (closes:
    #972193).

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 14 Oct 2020 17:56:59 +0200

libftdi1 (1.5-4) unstable; urgency=medium

  [ Aurelien Jarno ]
  * Fix debian/patches/01-cmake-multiarch.diff which was wrongly removing
    CMAKE_INSTALL_PREFIX from some variables (closes: #965177).

  [ Gianfranco Costamagna ]
  * Mark one symbol as optional, disappearing with -O3 (Closes: #965175).
  * Add an autopkgtest to test cmake scripts.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 17 Jul 2020 17:26:01 +0000

libftdi1 (1.5-3) unstable; urgency=medium

  * Redirect autopkgtests stderr output to stdout.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 14 Jul 2020 23:32:06 +0200

libftdi1 (1.5-2) unstable; urgency=medium

  * Add 03-cmake-project.diff patch to fix an includedir mismatch between
    libftdi1 and libftdipp1.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 13 Jul 2020 20:07:32 +0200

libftdi1 (1.5-1) unstable; urgency=medium

  * New upstream version:
    - Refresh debian/patches/01-cmake-multiarch.diff.
    - Update libftdi1-2 symbols file.
  * Add libftdipp1-3 symbols file.
  * Build and run tests.
  * Install the ftdi-eeprom config file example (closes: #897929).
  * Bump Standards-Version to 4.5.0 (no changes).
  * Add a watch file
  * Run upstream tests in autopkgtests.
  * Update ftdi-eeprom man page (closes: #849871).

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 12 Jul 2020 16:07:29 +0200

=== debian/control ===
Source: libftdi1
Section: libs
Priority: optional
Maintainer: Aurelien Jarno <aurel32@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libusb-1.0-0-dev, pkgconf
Build-Depends-Arch: dh-sequence-python3,
                    libboost-test-dev,
                    libconfuse-dev,
                    libpython3-all-dev,
                    python3-all:any,
                    python3-setuptools,
                    swig
Build-Depends-Indep: doxygen
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://www.intra2net.com/en/developer/libftdi/
Vcs-Git: https://salsa.debian.org/aurel32/libftdi1.git
Vcs-Browser: https://salsa.debian.org/aurel32/libftdi1

Package: ftdi-eeprom
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Tool for reading/erasing/flashing FTDI USB chip EEPROMs
 ftdi-eeprom is a small tool for creating and uploading the configuration
 EEPROM for the FTDI chip. This eeprom contains information such as vendor
 and product ID, manufacturer and product strings, revision, etc.

Package: libftdi1-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C Library to control and program the FTDI USB controllers
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 Functionalities include the possibility to use the chips in standard
 mode, in bitbang mode, and to read or write the serial EEPROM.
 .
 This is the C version of the library.

Package: libftdi1-dev
Section: libdevel
Architecture: any
Depends: libftdi1-2 (= ${binary:Version}), libusb-1.0-0-dev, ${misc:Depends}
Recommends: libftdi1-doc
Description: Development files for libftdi1
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 This package contains the header files and static library needed to
 compile applications that use libftdi1.

Package: libftdi1-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libftdi1-dev
Description: Documentation for libftdi1
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 This package contains the documentation of the libftdi1 library.

Package: libftdipp1-3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Library to control and program the FTDI USB controllers
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 Functionalities include the possibility to use the chips in standard
 mode, in bitbang mode, and to read or write the serial EEPROM.
 .
 This is the C++ version of the library.

Package: libftdipp1-dev
Section: libdevel
Architecture: any
Recommends: libftdi1-doc
Depends: libboost-dev (>= 1.58),
         libftdi1-dev (= ${binary:Version}),
         libftdipp1-3 (= ${binary:Version}),
         ${misc:Depends}
Description: Development files for libftdipp1
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 This package contains the header files and static library needed to
 compile applications that use libftdipp1.

Package: python3-ftdi1
Section: python
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Python module to control and program the FTDI USB controllers
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 Functionalities include the possibility to use the chips in standard
 mode, in bitbang mode, and to read or write the serial EEPROM.
 .
 This package provides the ftdi1 module on the Python 3 module path.

=== debian/tests/control ===
Tests: test-libftdi1
Depends: build-essential, libboost-test-dev, libftdi1-dev, pkg-config

Tests: test-libftdi1-cmake
Depends: build-essential, cmake, libboost-test-dev, libftdi1-dev

=== debian/watch ===
version=4
opts=pgpmode=auto \
    https://www.intra2net.com/en/developer/libftdi/download.php download/libftdi1-(.+)\.tar\.bz2
